# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.commit_id import CommitId  # noqa: F401,E501


class CommitMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'author': 'str',
        'properties': 'dict(str, str)',
        'commit_date': 'datetime',
        'commit_date_instant': 'int',
        'id': 'CommitId'
    }

    attribute_map = {
        'author': 'author',
        'properties': 'properties',
        'commit_date': 'commitDate',
        'commit_date_instant': 'commitDateInstant',
        'id': 'id'
    }

    def __init__(self, author=None, properties=None, commit_date=None, commit_date_instant=None, id=None):  # noqa: E501
        """CommitMetadata - a model defined in Swagger"""  # noqa: E501

        self._author = None
        self._properties = None
        self._commit_date = None
        self._commit_date_instant = None
        self._id = None
        self.discriminator = None

        if author is not None:
            self.author = author
        if properties is not None:
            self.properties = properties
        if commit_date is not None:
            self.commit_date = commit_date
        if commit_date_instant is not None:
            self.commit_date_instant = commit_date_instant
        if id is not None:
            self.id = id

    @property
    def author(self):
        """Gets the author of this CommitMetadata.  # noqa: E501


        :return: The author of this CommitMetadata.  # noqa: E501
        :rtype: str
        """
        return self._author

    @author.setter
    def author(self, author):
        """Sets the author of this CommitMetadata.


        :param author: The author of this CommitMetadata.  # noqa: E501
        :type: str
        """

        self._author = author

    @property
    def properties(self):
        """Gets the properties of this CommitMetadata.  # noqa: E501


        :return: The properties of this CommitMetadata.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this CommitMetadata.


        :param properties: The properties of this CommitMetadata.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def commit_date(self):
        """Gets the commit_date of this CommitMetadata.  # noqa: E501


        :return: The commit_date of this CommitMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._commit_date

    @commit_date.setter
    def commit_date(self, commit_date):
        """Sets the commit_date of this CommitMetadata.


        :param commit_date: The commit_date of this CommitMetadata.  # noqa: E501
        :type: datetime
        """

        self._commit_date = commit_date

    @property
    def commit_date_instant(self):
        """Gets the commit_date_instant of this CommitMetadata.  # noqa: E501


        :return: The commit_date_instant of this CommitMetadata.  # noqa: E501
        :rtype: int
        """
        return self._commit_date_instant

    @commit_date_instant.setter
    def commit_date_instant(self, commit_date_instant):
        """Sets the commit_date_instant of this CommitMetadata.


        :param commit_date_instant: The commit_date_instant of this CommitMetadata.  # noqa: E501
        :type: int
        """

        self._commit_date_instant = commit_date_instant

    @property
    def id(self):
        """Gets the id of this CommitMetadata.  # noqa: E501


        :return: The id of this CommitMetadata.  # noqa: E501
        :rtype: CommitId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CommitMetadata.


        :param id: The id of this CommitMetadata.  # noqa: E501
        :type: CommitId
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommitMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
